diff --git a/.gitignore b/.gitignore
index 71837ff88632002b4662d0cb6a9a0cf4493b0cee..a0d550376639dc1a22599bbe258ea41d572f7ea7 100644
--- a/.gitignore
+++ b/.gitignore
@@ -1,2 +1,3 @@
 vcsh.1
 *patch
+*.swp
diff --git a/_vcsh b/_vcsh
index 6ee95c8d1efc0f77bc1be48167fbf7b30dd05606..9f5b00658d0751c60ade48d957ef3dbe67522114 100644
--- a/_vcsh
+++ b/_vcsh
@@ -1,15 +1,15 @@
 #compdef vcsh
 
-#		use\:"use/enter repo"
-#		exit\:"exit repo"
 _arguments \
 	':subcommand:((
 		clone\:"clone from repo"
 		help\:"display help"
-		init\:"init & clone from repo"
 		delete\:"delete repo"
+		exit\:"Exit repo; unset"
+		init\:"init & clone from repo"
 		list\:"list all repos"
 		run\:"run command on repo"
 		seed-gitignore\:"seed .gitignore.d/foo from git ls-files"
+		use\:"Use repo; set ENV"
 		\<REPO\>\:"Run git command directly"
 	))'
diff --git a/doc/vcsh.1.ronn b/doc/vcsh.1.ronn
index 50810449395ecd3945f096c4ef6a291e9952bba1..744a0b3c81bf50b6f4c0a519b4f4bd661e4f8ce0 100644
--- a/doc/vcsh.1.ronn
+++ b/doc/vcsh.1.ronn
@@ -5,10 +5,12 @@ vcsh(1) - manage and sync config files via git
 
 `vcsh` clone <url> [<location>]
 
-`vcsh` help
-
 `vcsh` delete
 
+`vcsh` exit
+
+`vcsh` help
+
 `vcsh` init <repo>
 
 `vcsh` list
@@ -17,6 +19,8 @@ vcsh(1) - manage and sync config files via git
 
 `vcsh` seed-gitignore
 
+`vcsh` use <repo>
+
 `vcsh` <repo> <gitcommand>
 
 
@@ -43,12 +47,15 @@ A sample configuration for `vcsh` and `mr` can be found at
 * clone:
   Clone an existing repository.
 
-* help:
-  Display help.
-
 * delete:
   Delete an existing repository.
 
+* exit:
+  Exit repository; unset ENV
+
+* help:
+  Display help.
+
 * init:
   Initialize an empty repository.
 
@@ -62,6 +69,9 @@ A sample configuration for `vcsh` and `mr` can be found at
 * seed-gitignore:
   Seed .gitignore.d/<repo> from git ls-files.
 
+* use:
+  Use repository; set ENV
+
 * <repo> <gitcommand>:
   Shortcut to run `vcsh` on a repo. Will prepend `git` to <command> by itself.
 
diff --git a/vcsh b/vcsh
index 93b5d949ca8eb9c3790c301637f1eff6faf882f1..6fa6644aaed8b2462fe7070f53451ae12197675b 100755
--- a/vcsh
+++ b/vcsh
@@ -14,19 +14,18 @@ help() {
          [<repo>]       Clone from an existing repository
    help                 Display this help text
    delete               Delete an existing repository
+   exit                 Exit repository; unset ENV
    init <repo>          Initialize a new repository
-   list                 List all repos
+   list                 List all repositories
    run <repo> \\
        <command>        Use this repository
 
    seed-gitignore \\
    <repo>               Seed .gitignore.d/<repo> from git ls-files
+   use <repo>           Use repository; set ENV
 
    <repo> <git command> Special command that allows you to run git commands
                         directly without having to type so much ;)" >&2
-#   use <repo>     Use this repository
-#
-#   exit              Exit vcsh mode" >&2
 }
 
 debug() {
@@ -58,13 +57,13 @@ init() {
 	mkdir -p "$GIT_WORK_TREE"
 	cd "$GIT_WORK_TREE" ||
 		(echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
-		 exit 20) || exit 20
+		 return 1) || return $?
 	cd "$GIT_WORK_TREE"
 	git init
 	git config core.worktree     "$GIT_WORK_TREE"
-	git config core.excludesfile ".gitignore.d/$REPO_NAME"
-	touch   "$HOME/.gitignore.d/$REPO_NAME"
-	git add "$HOME/.gitignore.d/$REPO_NAME"
+	git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+	touch   "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+	git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
 	verbose "init() end"
 }
 
@@ -85,15 +84,19 @@ if [ "$1" = 'clone' ]; then
 elif [ "$1" = 'delete' ] ||
      [ "$1" = 'init' ] ||
      [ "$1" = 'run' ] ||
-     [ "$1" = 'seed-gitignore' ]; then
+     [ "$1" = 'seed-gitignore' ] ||
+     [ "$1" = 'use' ]; then
 	[ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
-	[ -z $3 ] && echo "$SELF $1 $2: error: please specify a command" && return 1
 	export VCSH_COMMAND="$1"
 	export VCSH_REPO_NAME="$2"
 	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
 	shift 2
 	export VCSH_EXTERNAL_COMMAND="$*"
-elif [ "$1" = 'help' ] ||
+	if [ "$VCSH_COMMAND" = 'run' ]; then
+		[ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
+	fi
+elif [ "$1" = 'exit' ] ||
+     [ "$1" = 'help' ] ||
      [ "$1" = 'list' ]; then
 	export VCSH_COMMAND="$1"
 else
@@ -112,10 +115,10 @@ do
 	if [ ! -d "$check_directory" ]; then
 		if [ -e "$check_directory" ]; then
 			echo "$SELF: error: $check_directory exists but is not a directory" >&2
-			exit 2
+			return 2
 		else
 			echo "$SELF: info: attempting to create $check_directory"
-			mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
+			mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; return 2) || return $?
 		fi
 	fi
 done
@@ -136,19 +139,20 @@ if [ "$VCSH_COMMAND" = 'clone' ]; then
 	[ "$VCSH_CONFLICT" = '1' ] &&
 		echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
 		echo "  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
-		exit 3
+		return 3
 	git merge origin/master
-#	use || return 1
+#	use || return $?
 	verbose "clone end"
 
-elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
+#elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
+elif [ "$VCSH_COMMAND" = 'help' ]; then
 	help
 
 elif [ "$VCSH_COMMAND" = 'delete' ]; then
 	verbose "delete begin"
 	old_dir="$PWD"
 	cd "$HOME"
-	use || return 1
+	use || return $?
 	echo "$SELF: info: This operation WILL DETROY DATA!"
 	files=$(git ls-files)
 	echo "These files will be deleted:
@@ -158,7 +162,7 @@ $files
 AGAIN, THIS WILL DELETE YOUR DATA!
 To continue, type \"Yes, do as I say\""
 	read answer
-	[ "x$answer" = "xYes, do as I say" ] || exit
+	[ "x$answer" = "xYes, do as I say" ] || return 1
 	for file in $files; do
 		rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
 	done
@@ -166,21 +170,21 @@ To continue, type \"Yes, do as I say\""
 	cd "$old_dir"
 	verbose "delete end"
 
-#elif [ "$VCSH_COMMAND" = 'exit' ]; then
-#	verbose "exit begin"
+elif [ "$VCSH_COMMAND" = 'exit' ]; then
+	verbose "exit begin"
 #	if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
 #		unset VCSH_NO_IGNORE_EOF
 #		setopt NO_IGNORE_EOF
 #	fi
-#	leave
+	leave
 #	[ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-#	verbose "exit end"
-#	exit 0
+	verbose "exit end"
+	return 0
 
 elif [ "$VCSH_COMMAND" = 'init' ]; then
 	verbose "init begin"
 	init
-#	use || return 1
+#	use || return $?
 	verbose "init end"
 
 elif [ "$VCSH_COMMAND" = 'list' ]; then
@@ -192,14 +196,14 @@ elif [ "$VCSH_COMMAND" = 'list' ]; then
 
 elif [ "$VCSH_COMMAND" = 'run' ]; then
 	verbose "run begin"
-	use || return 1
+	use || return $?
 	$VCSH_EXTERNAL_COMMAND
 	leave
 	verbose "run end"
 
 elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
 	verbose "seed-gitignore begin"
-	use || return 1
+	use || return $?
 	# Switching directory as this has to be executed from $HOME to be of any use.
 	# Going back into old directory at the end in case `vcsh use` is reactivated.
 	old_dir="$PWD"
@@ -211,28 +215,30 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
 			[ "$file" = "$new" ] && break
 			file="$new"
 		done;
-	done | sort -u | sed 's/^/!/')
+	done | sort -u)
 	tempfile=$(mktemp) ||
-		(echo "$SELF: fatal: could not create tempfile" && exit 1) 
+		(echo "$SELF: fatal: could not create tempfile" && return 1) || return $?
 	echo '*' > "$tempfile"
 	for gitignore in $gitignores; do
-		echo "$gitignore" >> "$tempfile"
+		echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
+		[ -d "$gitignore" ] && echo "$gitignore/*" | sed 's/^/!/'>> "$tempfile"
 	done
-	diff -N "$tempfile" "$HOME/.gitignore.d/$2" > /dev/null &&
+	diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
 		rm -f "$tempfile" &&
 		return
-	if [ -e "$HOME/.gitignore.d/$2" ]; then
-		echo "$SELF: info: $HOME/.gitignore.d/$2 differs from new data, moving it to $HOME/.gitignore.d/$2.bak"
-		mv -f "$HOME/.gitignore.d/$2" "$HOME/.gitignore.d/$2.bak" ||
-			(echo "$SELF: fatal: could not move $HOME/.gitignore.d/$2 to $HOME/.gitignore.d/$2.bak" && exit 1)
+	if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
+		echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
+		mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
+			(echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" &&
+			 return 1) || return $?
 	fi
-	mv -f "$tempfile" "$HOME/.gitignore.d/$2" ||
-		(echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$2" && exit 1)
+	mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
+		(echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && return 1) || return $?
 	cd "$old_dir"
 	verbose "seed-gitignore end"
 
-#elif [ "$VCSH_COMMAND" = 'use' ]; then
-#	verbose "use begin"
+elif [ "$VCSH_COMMAND" = 'use' ]; then
+	verbose "use begin"
 #	if [ -n "$ZSH_VERSION" ]; then
 #		if [ -o NO_IGNORE_EOF ]; then
 #			export VCSH_NO_IGNORE_EOF=1
@@ -245,14 +251,14 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
 #		zle -N vcsh_exit
 #		bindkey '^d' 'vcsh_exit'
 #	fi
-#	use || return 1
+	use || return $?
 #	[ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-#	verbose "use end"
+	verbose "use end"
 
 else
 	verbose "defaulting to calling help()"
 	help
 	echo "$SELF: fatal: You should never reach this code. File a bug, please."
-	exit 99
+	return 99
 
 fi